/**
 * @(#)file    BidIngBiz.java
 * @(#)author  Son Hyung Min 
 * @(#)version 1.0
 * @(#)date    2014-06-23
 * @(#)since   JDK 1.4.2
 */
package kr.co.udapsoft.ebid.buyer.bid.purchase.biz;



import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import oracle.toplink.internal.ox.StrBuffer;
import kr.co.hsnc.common.base.WAFLogger;
import kr.co.hsnc.common.sql.Row;
import kr.co.hsnc.common.sql.RowSet;
import kr.co.hsnc.common.sql.RowSetImpl;
import kr.co.hsnc.common.sql.WAFSQLException;
import kr.co.hsnc.common.sql.persistent.Persistent;
import kr.co.hsnc.common.sql.persistent.PersistentImpl;
import kr.co.hsnc.common.sql.search.Search;
import kr.co.hsnc.common.sql.search.SearchImpl;
import kr.co.hsnc.common.sql.util.RowSetUtility;
import kr.co.hsnc.common.util.ValueObject;
import kr.co.udapsoft.common.code.CommCodeManager;
import kr.co.udapsoft.ebid.buyer.common.file.FileManager;
import kr.co.udapsoft.ebid.buyer.sycs.user.biz.UserCommon;

import com.udapsoft.modular.web.ibsheet7.IBSheet7Factory;
import com.udapsoft.modular.web.ibsheet7.util.IBSheet7Utils;
import com.udapsoft.waf.system.Biz;
import com.udapsoft.waf.system.HandlerStorage;

   
public class SuccessBidBiz extends Biz {

	public SuccessBidBiz(HandlerStorage storage) {
		super(storage);
	}

	public void doBiz() throws Exception {
        ValueObject user = new ValueObject();
		
		if(storage.compareEvent("SHEET_SELECT")){
			params.set("sheet1", getBoardList(params));
			storage.addObject("ibsheet7Data", IBSheet7Factory.createIBSheet7(params, storage.request));
		}else if(storage.compareEvent("FORM_SELECT")){//견적의뢰
	            user = getOrderReqeustValueObject();
	            storage.addValueObject("Order", user);
	            /**		파일 목록 조회			 **/
		        storage.addValueObject(user.get("DOC_ETC_IN"), getfilelist(user.get("DOC_ETC_IN"),params.get("DEMANDED_ID"),user.get("DOC_ETC_IN")));
		        storage.addValueObject(user.get("DOC_ETC_OUT"), getfilelist(user.get("DOC_ETC_OUT"),params.get("DEMANDED_ID"),user.get("DOC_ETC_OUT")));
		        storage.addValueObject("SIGN_INFO", getSignInfo(params.get("DEMANDED_ID")));
		}else if(storage.compareEvent("FORM_SELECT_SITE")){//견적의뢰
            user = getOrderReqeustValueObject2(params.get("DEMANDED_ID"));
            storage.addValueObject("Order", user);
            /**		파일 목록 조회			 **/
	        storage.addValueObject(user.get("DOC_ETC_IN"), getfilelist(user.get("DOC_ETC_IN"),params.get("DEMANDED_ID"),user.get("DOC_ETC_IN")));
	        storage.addValueObject(user.get("DOC_ETC_OUT"), getfilelist(user.get("DOC_ETC_OUT"),params.get("DEMANDED_ID"),user.get("DOC_ETC_OUT")));
		}else if(storage.compareEvent("GET_CORP_LIST")){
			 params.set("sheet1", getCorpList(params.get("DEMANDED_ID")));
	         storage.addObject("ibsheet7Data", IBSheet7Factory.createIBSheet7(params, storage.request));
		}else if(storage.compareEvent("CLEAR_SAVE_LIST")){
			boolean success = false;
			success = clearSuppEsti(params);
			super.storage.setSuccess(success);
		}
		
		if(!storage.compareEvent("SHEET_SELECT")){
			if(!params.get("FILE_GB").isEmpty())
				storage.addValueObject(params.get("FILE_GB"), getfilelist(params.get("FILE_GB"),params.get("DEMANDED_ID"),params.get("FILE_GB")));
		}
	}
	
	private ValueObject getfilelist(String filegb,String id,String returnid){
		ValueObject vo = new ValueObject();
		RowSet rowSet = FileManager.getFileList(filegb, id);
		String str="";
	        for(int i=0;i<rowSet.size();i++){
	        	Row row=rowSet.getRow(i);
	        	str += (i+1)+" : "+row.get("FILE_NAME")+" ("+ row.get("FILE_SIZE")+")";
	        	if(i+1!=rowSet.size()){
	        		str +="\r\n";
	        	}
	        }
	        vo.set(returnid, str);
		return vo;
	}

	/**
	 * 발주의뢰(외주) 접수를 검색하여 리턴
	 * @param Params
	 * @return
	 */
	private RowSet getBoardList(ValueObject param) {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        
     //   String sqlstr = "";
        StrBuffer sqlstr = new StrBuffer();
        try{ 
        	sqlstr.append(" SELECT A.BID_DEG																															\n");
        	sqlstr.append("      , B.DEPT_NM																																\n");
        	sqlstr.append("      , A.BID_NO																																\n");
        	sqlstr.append("      , A.DEMANDED_TITLE																													\n");
        	sqlstr.append("      , A.BID_MASTER_NM																													\n");
        	sqlstr.append("      , A.ONBID_YN																															\n");
        	sqlstr.append("      , TO_CHAR(A.REQUEST_DATE,'YYYY-MM-DD') AS REQUEST_DATE														\n");
        	sqlstr.append("      , TO_CHAR(A.RECEIPT_DATE,'YYYY-MM-DD') AS RECEIPT_DATE															\n");
        	sqlstr.append("      , A.STATUS_CD 																															\n");
        	sqlstr.append("      , F_GET_CODE_NAME('BID_STATUS_CD',A.STATUS_CD) AS STATUS_NM												\n");
        	sqlstr.append("      , A.DEMANDED_ID		 																												\n");
        	sqlstr.append("      , TO_CHAR(A.OPEN_DT,'YYYY-MM-DD HH24:MI') AS OPEN_DT															\n");
        	sqlstr.append("      , A.OPEN_EMPNM		 																												\n");
        	sqlstr.append("      , TO_CHAR(C.TBE_FIN_DT,'YYYY-MM-DD HH24:MI') AS TBE_FIN_DT													\n");
        	sqlstr.append("   FROM BID_MASTER A	, ACZ10100V B	, TBE_INFO	C																				\n");
        	sqlstr.append("   WHERE A.DEPT_CD = B.DEPT_CD																										\n");
        	sqlstr.append("   AND A.BID_NO = C.BID_NO(+)																											\n");
        	sqlstr.append("   AND A.BID_DEG = C.BID_DEG(+)																										\n");
        	sqlstr.append("   AND A.STATUS_CD IN ('04','05','06')																								\n");
        	sqlstr.append("   AND A.DEMANDED_KIND IN ('C','P','B')	       																						\n");
        	sqlstr.append("   AND A.OPEN_DT IS NOT NULL																											\n");
        	// 현장
        	if(!"".equals(params.get("P_DEPT_CD"))) {
        		sqlstr.append(" AND A.DEPT_CD = ?																												 \n");
    			search.addParameter(params.get("P_DEPT_CD"));
        	}
        	if(!param.get("P_BID_MASTER_NM").isEmpty())
        		sqlstr.append("   AND UPPER(A.BID_MASTER_NM) LIKE '%'|| '"+param.get("P_BID_MASTER_NM").toUpperCase()+"' ||'%'																	\n");
        	if(!param.get("P_DEMANDED_FROM_DT").isEmpty() && !param.get("P_DEMANDED_TO_DT").isEmpty())
        		sqlstr.append("   AND A.REQUEST_DATE BETWEEN  '"+param.get("P_DEMANDED_FROM_DT")+"' AND '"+param.get("P_DEMANDED_TO_DT")+"'		\n");
        	if(!param.get("P_RCEIPT_FROM_DT").isEmpty() && !param.get("P_RCEIPT_TO_DT").isEmpty())
        		sqlstr.append("   AND A.REQUEST_DATE BETWEEN  '"+param.get("P_RCEIPT_FROM_DT")+"' AND '"+param.get("P_RCEIPT_TO_DT")+"'					\n");
        	if(!param.get("P_DEMANDED_STATUS").isEmpty())
        		sqlstr.append("   AND A.STATUS_CD = '"+param.get("P_DEMANDED_STATUS")+"'																						\n");
        	
        	sqlstr.append("   ORDER BY OPEN_DT DESC 																																			\n");
			search.setStatement(sqlstr.toString());
            rowSet = search.execute();
        }
        catch (WAFSQLException se) {
            super.doException(se);
            this.storage.setSuccess(false);  
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {    
            if(rowSet == null){
            	rowSet = new RowSetImpl();
            }
        }
        return rowSet;
	}
	

	
	/**
	 * 발주의뢰(외주) 접수 상세를 검색하여 리턴
	 * @param Params
	 * @return
	 */
	private ValueObject getOrderReqeustValueObject() {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        ValueObject valueobject = null;
     //   String sqlstr = "";
        StrBuffer sqlstr = new StrBuffer();
        try{
               sqlstr.append("       SELECT TO_CHAR(TO_DATE(A.DEMANDED_DATE,'YYYYMMDD'),'YYYY-MM-DD') AS DEMANDED_DATE,                                        \n");
		       sqlstr.append("       A.DEMANDED_TITLE,                                        \n");
		       sqlstr.append("       A.DEMANDED_KIND,                                        \n");
		       sqlstr.append("       F_GET_CODE_NAME('911',A.CURRENCY_GB) AS CURRENCY_GB_NM,                                        \n");
		       sqlstr.append("       A.CURRENCY_GB,                                        \n");
		       sqlstr.append("       NVL((SELECT CHG_CODE01 FROM EBID_COM911T WHERE BASECD = '911' AND DETAILCD =A.CURRENCY_GB),0) AS PointCount,        \n");
		       sqlstr.append("       A.DEPT_CD,                                        \n");
		       sqlstr.append("       A.EMP_NO,                                        \n");
		       sqlstr.append("       GET_USER_BUSEO_NM(A.EMP_NO) AS BUSEO_NM,                                          \n");
		       sqlstr.append("       A.DELIVERY_CONDITION,                                        \n");
		       sqlstr.append("       A.CRE_BY,                                        \n");
		       sqlstr.append("       A.CRE_DATE,                                        \n");
		       sqlstr.append("       A.UPD_BY,                                        \n");
		       sqlstr.append("       A.UPD_DATE,                                        \n");
		       sqlstr.append("       A.DEMANDED_NO,                                        \n");
		       sqlstr.append("       A.BID_APP_DATE,                                        \n");
		       sqlstr.append("       A.BID_APP_NO,                                        \n");
		       sqlstr.append("       A.PAY_ITEM,                                        \n");
		       sqlstr.append("       F_GET_PAY_ITEM_VIEW(A.PAY_ITEM,A.COST_CODE,A.COST_TYPE,A.DEPT_CD) AS PAY_ITEM_NM,                \n");
		       sqlstr.append("       A.COST_CODE,                                        \n");
		       sqlstr.append("       A.COST_TYPE,                                        \n");
		       sqlstr.append("       TO_CHAR(A.RECEIPT_DATE,'YYYY-MM-DD') AS RECEIPT_DATE,                                        \n");
		       sqlstr.append("       DECODE(A.SITEDESC_FLAG,'Y','예','N','아니오','') AS SITEDESC_FLAG,                                        \n");
		       sqlstr.append("       A.SITEDESCCHRGPRSNID,                                        \n");
		       sqlstr.append("       F_GET_USER_NM(A.SITEDESCCHRGPRSNID) AS SITEDESCCHRGPRSNNM,                                        \n");
		       sqlstr.append("       A.SITEDESCTELNO,                                        \n");
		       sqlstr.append("       TO_CHAR(A.SITEDESCDATE,'YYYY-MM-DD HH24:MI') AS SITEDESCDATE,                                        \n");
		       sqlstr.append("       TO_CHAR(A.SITEDESCDATE,'YYYY-MM-DD') AS SITEDESCDT,                                        \n");
		       sqlstr.append("       A.SITEDESCPLACE,                                        \n");
		       sqlstr.append("       A.SITEDESCEMAIL,                                        \n");
		       sqlstr.append("       A.PUREMPNO,                                        \n");
		       sqlstr.append("       F_GET_USER_NM(A.PUREMPNO) AS PUREMPNM,                                        \n");
		       sqlstr.append("       A.INNER_REMARKS,                                        \n");
		       sqlstr.append("       A.TBE_FLAG,                                        \n");
		       sqlstr.append("       DECODE(A.TBE_FLAG,'Y','예','N','아니오','') AS TBE_FLAG_NM,                   \n");
		       sqlstr.append("       A.OUTER_REMARKS,                                        \n");
		       sqlstr.append("       A.DEMANDED_ID,                                        \n");
		       sqlstr.append("       TO_CHAR(A.REQUEST_DATE,'YYYY-MM-DD') AS REQUEST_DATE,                                        \n");
		       sqlstr.append("       A.ATT_ID,                                        \n");
		       sqlstr.append("       A.BID_NO,                                        \n");
		       sqlstr.append("       A.BID_DEG,                                        \n");
		       sqlstr.append("       A.ONBID_YN,                                       \n");
		       sqlstr.append("       F_GET_CODE_NAME('ONBID',ONBID_YN) AS ONBID_YN_NM,                                       \n");
		       sqlstr.append("       F_GET_CODE_NAME('CMPT_CD',A.CMPT_CD) AS CMPT_NM,                                        \n");
		       sqlstr.append("       A.CMPT_CD,                                        \n");
		       sqlstr.append("       F_GET_CODE_NAME('SUCC_CD',A.SUCC_CD) AS SUCC_NM,                                        \n");
		       sqlstr.append("       A.SUCC_CD,                                        \n");
		       sqlstr.append("       TO_CHAR(TO_DATE(A.NOTI_DY,'YYYYMMDD'),'YYYY-MM-DD') AS NOTI_DY,                                        \n");
		       sqlstr.append("       A.SITEDESC_CRG_NM,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_FROM_DT,'YYYY-MM-DD HH24:MI') AS BID_FROM_DT,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_TO_DT,'YYYY-MM-DD HH24:MI') AS BID_TO_DT,                                        \n");
		       sqlstr.append("       A.PO_EMPNM,                                        \n");
		       sqlstr.append("       A.OPEN_EMPNM,                                        \n");
		       sqlstr.append("       A.OPEN_EMPID,                                        \n");
		       sqlstr.append("       TO_CHAR(TO_DATE(A.DELI_FROM_DY,'YYYYMMDD'),'YYYY-MM-DD') AS DELI_FROM_DY,                                        \n");
		       sqlstr.append("       TO_CHAR(TO_DATE(A.DELI_TO_DY,'YYYYMMDD'),'YYYY-MM-DD') AS DELI_TO_DY,                                        \n");
		       sqlstr.append("       A.DELIVERY_PLACE,                                        \n");
		       sqlstr.append("       A.CONTFUL_RATE,                                        \n");
		       sqlstr.append("       A.CONTFUL_CONDI,                                        \n");
		       sqlstr.append("       A.WARR_RATE,                                        \n");
		       sqlstr.append("       A.WARR_CONDI,                                        \n");
		       sqlstr.append("       A.DEPT_NM,                                        \n");
		       sqlstr.append("       A.REQ_DEPT_CD,                                        \n");
		       sqlstr.append("       A.REQ_DEPT_NM,                                        \n");
		       sqlstr.append("       A.EMP_NM,                                        \n");
		       sqlstr.append("       A.STATUS_CD,                                        \n");
		       sqlstr.append("       F_GET_CODE_NAME('BID_STATUS_CD',A.STATUS_CD) AS STATUS_NM,                                      \n");    
		       sqlstr.append("       A.OPEN_DT,                                        \n");
		       sqlstr.append("       A.CONT_APP_DATE,                                        \n");
		       sqlstr.append("       A.CONT_APP_NO,                                        \n");
		       sqlstr.append("       A.CONT_AMT,                                        \n");
		       sqlstr.append("       A.ACT_AMT,                                        \n");
		       sqlstr.append("       A.PUR_AMT,                                        \n");  //2015.02.27 구매외주예산추가 mklee
		       sqlstr.append("       A.ACT_RATE,                                        \n");
		       sqlstr.append("       A.DOC_ETC_IN,                                        \n");
		       sqlstr.append("       A.DOC_ETC_OUT,                                        \n");
		       sqlstr.append("       A.BID_MASTER_NM,                                        \n");
		       sqlstr.append("       A.OPEN_OPINION,                                        \n"); //2015.3.27 개찰의견 MKLEE
		       sqlstr.append("       A.POSTPONE_REASON,                                        \n");
		       sqlstr.append("       A.CANCEL_REASON,                                        \n");
		       sqlstr.append("       A.CURRENCY_GB_YN,                                        \n");
		       sqlstr.append("       A.DELIVERY_CONDITION_YN,                                        \n");
		       //sqlstr.append("       A.EXCHANGE                                        \n");
		       sqlstr.append("       TO_CHAR(B.SUPP_REQ_DY,'YYYY-MM-DD') AS SUPP_REQ_DY,                                        \n");
		       sqlstr.append("       B.EVAL_EMPNM,                                        \n");
		       sqlstr.append("       B.EVAL_EMPID,                                        \n");
		       sqlstr.append("       TO_CHAR(TBE_FIN_DT,'YYYY-MM-DD') AS TBE_FIN_DT,				\n");
		       sqlstr.append("       A.OUT_ITEM_CD,                                        \n");
		       sqlstr.append("       GET_OUT_ITEM_NM(A.OUT_ITEM_CD) AS OUT_ITEM_NM,						\n");
		       sqlstr.append("       A.CURRENCY_GB_YN,													\n");
		       sqlstr.append("       A.PBC_DEFECT_CONDI,			\n");
		       sqlstr.append("       A.CBC_DERECT_TERM_CD,			\n");
		       sqlstr.append("       F_GET_CODE_NAME('CBC_DERECT_TERM_CD',A.CBC_DERECT_TERM_CD) AS CBC_DERECT_TERM_NM,			\n");
		       sqlstr.append("       A.CBC_DEFECT_DAY,				\n");
		       sqlstr.append("       A.PBC_DEFECT_CONDI2,			\n");
		       sqlstr.append("       A.CBC_DERECT_TERM_CD2,			\n");
		       sqlstr.append("       A.CBC_DEFECT_DAY2,				\n");
		       sqlstr.append("       A.WARR_RATE,				\n");
		       sqlstr.append("       A.WARR_CONDI,				\n");
		       sqlstr.append("       A.CONTFUL_RATE,				\n");
		       sqlstr.append("       A.CONTFUL_CONDI,			\n");
		       sqlstr.append("       A.PBC_FRSTGUAR_RATE,			\n");
		       sqlstr.append("       A.PBC_FRSTGUAR_CONDI,			\n");
		       sqlstr.append("       A.PBC_REST_RATE,				\n");
		       sqlstr.append("       A.PBC_REST_CONDI,				\n");
		       sqlstr.append("       A.CPC_MID_RATE,				\n");
		       sqlstr.append("       A.PBC_MID_CONDI,				\n");
		       sqlstr.append("       A.CBC_FIRST_RATE,				\n");
		       sqlstr.append("       A.PBC_FIRST_CONDI,			\n");
		       sqlstr.append("       A.CBC_DAMAGE_RATE,			\n");
		       sqlstr.append("       A.CBC_DAMAGE_MAXRATE,			\n");
		       sqlstr.append("       F_GET_CODE_NAME('LIQ_DMG_CD', A.CBC_DAMAGE_CD) AS CBC_DAMAGE_NM,			\n");
		       sqlstr.append("       A.PBC_OPTION_COMMENT,			\n");
		       sqlstr.append("       A.PBC_OPTION_YN,				\n");
		       sqlstr.append("       A.PBC_FEE_YN,				\n");
		       sqlstr.append("       A.DELIVERY_CONDITION,			\n");
		       sqlstr.append("       F_GET_CODE_NAME('PUR_LEAD_GB',A.DELIVERY_CONDITION) AS DELIVERY_CONDITION_NM,			\n");
		       sqlstr.append("       A.DELIVERY_CONDITION_YN,			\n");
		       sqlstr.append("       A.PBC_LANDTRAN_YN,			\n");
		       sqlstr.append("       A.PBC_PACK_YN,				\n");
		       sqlstr.append("       A.PBC_DOC_YN,				\n");
		       sqlstr.append("       A.PBC_TEST_YN,				\n");
		       sqlstr.append("       A.PBC_SPETOOL_YN,				\n");
		       sqlstr.append("       A.PBC_COMMISS_YN,				\n");
		       sqlstr.append("       A.PBC_INSTALL_YN,				\n");
		       sqlstr.append("       A.PBC_CBE_TYPE_CD,			\n");
		       sqlstr.append("       A.KRW_APPR_YN,				\n");
		       sqlstr.append("       A.DIV_PO_YN	,					\n");
		       sqlstr.append("       A.CON_REMARK	,					\n");
		       sqlstr.append("       A.DIV_CONT_YN	,					\n");
		       sqlstr.append("       nvl(A.PAY_DIV,1) as pay_div	,					\n");
		       sqlstr.append("       A.REBID_REASON,		    		\n");  //2015.3.3 재입찰사유표기 mklee		       
		       sqlstr.append("       A.REBID_OUTREASON,		    		\n");  //2015.3.19 재입찰		       
		       sqlstr.append("       (SELECT COUNT(*) FROM PMM_DEMANDED_REQUEST WHERE DEMANDED_NO = A.DEMANDED_NO AND PR_TYPE = '20' and demanded_status in ('3', '4') AND NVL(EBID_STATUS_CD,'01') = '01')	AS FOR_PO,					\n");
		       sqlstr.append("       A.MAIN_PR_CONTENTS,		    	\n");
		       sqlstr.append("       A.BID_SUPP_SELECT_REASON		    \n");
		       sqlstr.append("        FROM BID_MASTER A  , TBE_INFO B                                      \n");
		       sqlstr.append("       WHERE A.BID_NO = '"+params.get("BID_NO")+"'							\n");
		       sqlstr.append("       AND A.BID_DEG = '"+params.get("BID_DEG")+"'							\n");
		       sqlstr.append("       AND A.BID_NO = B.BID_NO(+)							\n");
			   sqlstr.append("       AND A.BID_DEG = B.BID_DEG(+)							\n");
			   sqlstr.append("  	  AND A.DEMANDED_KIND IN ('C','P','B')	       																									\n");
        	search.setStatement(sqlstr.toString());
            rowSet = search.execute();
            if( rowSet != null && rowSet.size() > 0 ){
            	valueobject = RowSetUtility.getValueObject(rowSet.getRow(0));
            }
        }
        catch(WAFSQLException se) {
        	super.doException(se);
            this.storage.setSuccess(false);
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {

        	if( valueobject == null ) valueobject = new ValueObject();
            return valueobject;
        }
	}
	
	/**
	 * 발주의뢰(외주) 접수 상세를 검색하여 리턴
	 * @param Params
	 * @return
	 */
	private ValueObject getOrderReqeustValueObject2(String DEMANDED_ID) {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        ValueObject valueobject = null;
     //   String sqlstr = "";
        StrBuffer sqlstr = new StrBuffer();
        try{
            	sqlstr.append("       SELECT TO_CHAR(TO_DATE(A.DEMANDED_DATE,'YYYYMMDD'),'YYYY-MM-DD') AS DEMANDED_DATE,                                        \n");
		       sqlstr.append("       A.DEMANDED_TITLE,                                        \n");
		       sqlstr.append("       A.DEMANDED_KIND,                                        \n");
		       sqlstr.append("       A.CURRENCY_GB,                                        \n");
		       sqlstr.append("       A.DEPT_CD,                                        \n");
		       sqlstr.append("       A.EMP_NO,                                        \n");
		       sqlstr.append("       GET_USER_BUSEO_NM(A.EMP_NO) AS BUSEO_NM,                                          \n");
		       sqlstr.append("       A.DELIVERY_CONDITION,                                        \n");
		       sqlstr.append("       A.CRE_BY,                                        \n");
		       sqlstr.append("       A.CRE_DATE,                                        \n");
		       sqlstr.append("       A.UPD_BY,                                        \n");
		       sqlstr.append("       A.UPD_DATE,                                        \n");
		       sqlstr.append("       A.DEMANDED_NO,                                        \n");
		       sqlstr.append("       A.BID_APP_DATE,                                        \n");
		       sqlstr.append("       A.BID_APP_NO,                                        \n");
		       sqlstr.append("       A.PAY_ITEM,                                        \n");
		       sqlstr.append("       F_GET_PAY_ITEM_VIEW(A.PAY_ITEM,A.COST_CODE,A.COST_TYPE,A.DEPT_CD) AS PAY_ITEM_NM,                \n");
		       sqlstr.append("       A.COST_CODE,                                        \n");
		       sqlstr.append("       A.COST_TYPE,                                        \n");
		       sqlstr.append("       TO_CHAR(A.RECEIPT_DATE,'YYYY-MM-DD') AS RECEIPT_DATE,                                        \n");
		       sqlstr.append("       A.SITEDESC_FLAG,                                    \n");
		       sqlstr.append("       A.SITEDESCCHRGPRSNID,                                        \n");
		       sqlstr.append("       F_GET_USER_NM(A.SITEDESCCHRGPRSNID) AS SITEDESCCHRGPRSNNM,                                        \n");
		       sqlstr.append("       A.SITEDESCTELNO,                                        \n");
		       sqlstr.append("       TO_CHAR(A.SITEDESCDATE,'YYYY-MM-DD HH24:MI') AS SITEDESCDATE,                                        \n");
		       sqlstr.append("       TO_CHAR(A.SITEDESCDATE,'YYYY-MM-DD') AS SITEDESCDT,                                        \n");
		       sqlstr.append("       A.SITEDESCPLACE,                                        \n");
		       sqlstr.append("       A.SITEDESCEMAIL,                                        \n");
		       sqlstr.append("       A.PUREMPNO,                                        \n");
		       sqlstr.append("       F_GET_USER_NM(A.PUREMPNO) AS PUREMPNM,                                        \n");
		       sqlstr.append("       A.INNER_REMARKS,                                        \n");
		       sqlstr.append("       A.TBE_FLAG,                                    	   \n");
		       sqlstr.append("       A.OUTER_REMARKS,                                        \n");
		       sqlstr.append("       A.DEMANDED_ID,                                        \n");
		       sqlstr.append("       TO_CHAR(A.REQUEST_DATE,'YYYY-MM-DD') AS REQUEST_DATE,                                        \n");
		       sqlstr.append("       A.ATT_ID,                                        \n");
		       sqlstr.append("       A.BID_NO,                                        \n");
		       sqlstr.append("       A.BID_DEG,                                        \n");
		       sqlstr.append("       A.ONBID_YN,                                       \n");
		       sqlstr.append("       F_GET_CODE_NAME('ONBID',ONBID_YN) AS ONBID_YN_NM,                                       \n");
		       sqlstr.append("       F_GET_CODE_NAME('CMPT_CD',A.CMPT_CD) AS CMPT_NM,                                        \n");
		       sqlstr.append("       A.CMPT_CD,                                        \n");
		       sqlstr.append("       F_GET_CODE_NAME('SUCC_CD',A.SUCC_CD) AS SUCC_NM,                                        \n");
		       sqlstr.append("       A.SUCC_CD,                                        \n");
		       sqlstr.append("       TO_CHAR(TO_DATE(A.NOTI_DY,'YYYYMMDD'),'YYYY-MM-DD') AS NOTI_DY,                                        \n");
		       sqlstr.append("       A.SITEDESC_CRG_NM,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_FROM_DT,'YYYY-MM-DD') AS BID_FROM_DT,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_FROM_DT,'HH24') AS BID_FROM_HH,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_FROM_DT,'MI') AS BID_FROM_MI,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_TO_DT,'YYYY-MM-DD') AS BID_TO_DT,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_TO_DT,'HH24') AS BID_TO_HH,                                        \n");
		       sqlstr.append("       TO_CHAR(A.BID_TO_DT,'MI') AS BID_TO_MI,                                        \n");
		       sqlstr.append("       A.PO_EMPNM,                                        \n");
		       sqlstr.append("       A.OPEN_EMPNM,                                        \n");
		       sqlstr.append("       A.OPEN_EMPID,                                        \n");
		       sqlstr.append("       TO_CHAR(TO_DATE(A.DELI_FROM_DY,'YYYYMMDD'),'YYYY-MM-DD') AS DELI_FROM_DY,                                        \n");
		       sqlstr.append("       TO_CHAR(TO_DATE(A.DELI_TO_DY,'YYYYMMDD'),'YYYY-MM-DD') AS DELI_TO_DY,                                        \n");
		       sqlstr.append("       A.DELIVERY_PLACE,                                        \n");
		       sqlstr.append("       A.CONTFUL_RATE,                                        \n");
		       sqlstr.append("       A.CONTFUL_CONDI,                                        \n");
		       sqlstr.append("       A.WARR_RATE,                                        \n");
		       sqlstr.append("       A.WARR_CONDI,                                        \n");
		       sqlstr.append("       A.DEPT_NM,                                        \n");
		       sqlstr.append("       A.REQ_DEPT_CD,                                        \n");
		       sqlstr.append("       A.REQ_DEPT_NM,                                        \n");
		       sqlstr.append("       A.EMP_NM,                                        \n");
		       sqlstr.append("       A.STATUS_CD,                                        \n");
		       sqlstr.append("       A.OPEN_DT,                                        \n");
		       sqlstr.append("       A.CONT_APP_DATE,                                        \n");
		       sqlstr.append("       A.CONT_APP_NO,                                        \n");
		       sqlstr.append("       A.CONT_AMT,                                        \n");
		       sqlstr.append("       A.ACT_AMT,                                        \n");
		       sqlstr.append("       A.PUR_AMT,                                        \n");  //2015.02.27 구매외주예산추가 mklee
		       sqlstr.append("       A.ACT_RATE,                                        \n");
		       sqlstr.append("       A.DOC_ETC_IN,                                        \n");
		       sqlstr.append("       A.DOC_ETC_OUT,                                        \n");
		       sqlstr.append("       A.BID_MASTER_NM,                                        \n");
		       sqlstr.append("       A.POSTPONE_REASON,                                        \n");
		       sqlstr.append("       A.CANCEL_REASON,                                        \n");
		       sqlstr.append("       A.CURRENCY_GB_YN,                                        \n");
		       sqlstr.append("       A.DELIVERY_CONDITION_YN,                                        \n");
		       //sqlstr.append("       A.EXCHANGE                                        \n");
		       sqlstr.append("       TO_CHAR(B.SUPP_REQ_DY,'YYYY-MM-DD') AS SUPP_REQ_DY,                                        \n");
		       sqlstr.append("       B.EVAL_EMPNM,                                        \n");
		       sqlstr.append("       B.EVAL_EMPID,                                        \n");
		       sqlstr.append("       GET_OUT_ITEM_NM(A.OUT_ITEM_CD) AS OUT_ITEM_NM						\n");
		       sqlstr.append("        FROM BID_MASTER A  , TBE_INFO B                                      \n");
		       sqlstr.append("       WHERE A.BID_NO = '"+params.get("BID_NO")+"'	\n");
		       sqlstr.append("       AND A.BID_DEG = '"+params.get("BID_DEG")+"'		\n");
		       sqlstr.append("       AND A.BID_NO = B.BID_NO(+)							\n");
			   sqlstr.append("       AND A.BID_DEG = B.BID_DEG(+)							\n");
			   sqlstr.append("  	  AND A.DEMANDED_KIND IN ('C','P','B')	       																									\n");

        	search.setStatement(sqlstr.toString());
            rowSet = search.execute();
            if( rowSet != null && rowSet.size() > 0 ){
            	valueobject = RowSetUtility.getValueObject(rowSet.getRow(0));
            }
        }
        catch(WAFSQLException se) {
        	super.doException(se);
            this.storage.setSuccess(false);
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {

        	if( valueobject == null ) valueobject = new ValueObject();
            return valueobject;
        }
	}
	
	/**
	 * 발주의뢰(외주) 접수 상세 / 견적대상업체 를 검색하여 리턴
	 * @param Params
	 * @return
	 */
	private RowSet getCorpList(String DEMANDED_ID) {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        
     //   String sqlstr = "";
        StrBuffer sqlstr = new StrBuffer();
        try{
        	sqlstr.append(" SELECT A.BID_NO,										\n");
        	sqlstr.append("        A.BID_DEG,											\n");
        	sqlstr.append("        A.VENDOR_CD,										\n");
        	sqlstr.append("        A.VENDOR_NO,										\n");
        	sqlstr.append("        A.VENDOR_NAME,									\n");
        	sqlstr.append("        A.REPRE_NO,										\n");
        	sqlstr.append("        A.CHARGE_NAME,									\n");
        	sqlstr.append("        A.CHAGE_HP,										\n");
        	sqlstr.append("        A.CHARGE_EMAIL,									\n");
        	sqlstr.append("        DECODE(B.CURRENCY_GB,'KRW',1,A.EXCHANGE) AS EXCHANGE,										\n");
        	sqlstr.append("        A.DELIVERY_CONDITION,						\n");
        	sqlstr.append("        DECODE((SELECT SITEDESC_FLAG FROM BID_MASTER WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG),'Y',A.SITEPARTI_YN,'Y') AS SITEPARTI_YN,			\n");
        	sqlstr.append("        NVL(A.SITE_ATTEND_YN,'NULL') AS SITE_ATTEND_YN,					\n");
        	sqlstr.append("        A.TBEAPPR_YN,									\n");
        	sqlstr.append("        A.TBEEVALUATE_YN,								\n");
        	sqlstr.append("        A.CERT_DN,											\n");
        	sqlstr.append("        A.ESTI_SIGNDATA,								\n");
        	sqlstr.append("        DECODE(A.SIGN_DT,'','미제출',TO_CHAR(A.SIGN_DT,'YYYY-MM-DD HH24:MI:SS')) AS SIGN_DT,				\n");
        	sqlstr.append("        A.ATT_ID,											\n");
        	sqlstr.append("        A.RECM_DEPT_ID,									\n");
        	sqlstr.append("        A.RECM_DEPT_NM,								\n");
        	sqlstr.append("        A.RECM_EMPID,									\n");
        	sqlstr.append("        A.RECOMMEND_REASON,						\n");
        	sqlstr.append("        CASE WHEN A.SITEPARTI_YN = 'Y' AND ESTI_TOT_AMT > 0 THEN  F_GET_D_CURRENCY(A.ESTI_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB)))												\n");
        	sqlstr.append("       			WHEN (SELECT ONBID_YN FROM  BID_MASTER WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG) = 'N' AND A.ESTI_TOT_AMT > 0 THEN F_GET_D_CURRENCY(A.ESTI_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB)))			\n");
			sqlstr.append("       			WHEN ESTI_TOT_AMT IS NULL AND RNNC_REASON IS NULL AND (SELECT ONBID_YN FROM BID_MASTER WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG) = 'N' THEN '견적서작성'			\n");
			sqlstr.append("       			WHEN ESTI_TOT_AMT IS NULL AND RNNC_REASON IS NULL  THEN '미참여'																									\n");
			sqlstr.append("       			WHEN (SELECT DIV_PO_YN FROM  BID_MASTER WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG) ='Y' THEN '단가계약'									\n");
			sqlstr.append("       			WHEN RNNC_SIGNDATA IS NOT NULL THEN '입찰포기('||TO_CHAR(BID_RNNC_DT,'YYYY-MM-DD HH24:MI')||')'														\n");
			sqlstr.append("        		ELSE F_GET_D_CURRENCY(A.ESTI_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB))) END AS ESTI_TOT_AMT,																						\n");
			sqlstr.append("        CASE WHEN A.ESTI_TOT_AMT = -1 THEN 0			\n");
			sqlstr.append("        ELSE ROUND((DECODE(B.CURRENCY_GB,'KRW',A.ESTI_TOT_AMT,A.WON_ESTI_TOT_AMT)/(SELECT DECODE(PUR_AMT,0,1,NVL(PUR_AMT,1)) FROM  BID_MASTER WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG) * 100),1) END  AS ESTI_TOT_RATE, 			\n");  //DECODE(NVL(PUR_AMT, 1),1,NVL(ACT_AMT, 1),NVL(PUR_AMT,1)) 구매예산대비 2015.3.2 MKLEE
        	sqlstr.append("        DECODE(B.CURRENCY_GB,'KRW',F_GET_D_CURRENCY(A.ESTI_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB))),F_GET_D_CURRENCY(A.WON_ESTI_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB)))) AS WON_ESTI_TOT_AMT,						\n");
        	sqlstr.append("        A.BID_RNNC_DT,									\n");
        	sqlstr.append("        A.BID_RNNC_ID,									\n");
        	sqlstr.append("        A.BID_RNNC_NM,									\n");
        	sqlstr.append("        A.RNNC_REASON,									\n");
        	sqlstr.append("        nvl(A.ESTI_TOT_AMT,0) AS ESTI_TOT_AMT_I,	\n");
        	sqlstr.append("        A.SELECT_TOT_AMT AS SELECT_TOT_AMT_I,	\n");
        	sqlstr.append("        DECODE(A.SUCC_YN,'Y','1','0') AS SUCC_YN_CK,												\n");
        	sqlstr.append("        DECODE(A.SUCC_YN,'Y','1','0') AS SUCC_YN_CK2,												\n");
        	sqlstr.append("        A.FIB_REASON,									\n");
        	sqlstr.append("        DECODE(DISQ_REASON,NULL,'[등록]','[수정]') AS DISQ_YN,									\n");
        	sqlstr.append("        A.FILE_GB,											\n");
        	sqlstr.append("        A.DISQ_REASON,									\n");
        	sqlstr.append("        A.CRE_BY,											\n");
        	sqlstr.append("        A.CRE_DATE,										\n");
        	sqlstr.append("        A.UPD_BY,											\n");
        	sqlstr.append("        A.UPD_DATE,										\n");
        	sqlstr.append("        B.CURRENCY_GB_YN,								\n");
        	sqlstr.append("        B.CURRENCY_GB,									\n");
        	sqlstr.append("        F_GET_CODE_NAME('CURRENCY_GB',B.CURRENCY_GB) AS CURRENCY_GB_NM,			\n");
        	sqlstr.append("        B.INSTALL_YN,										\n");
        	sqlstr.append("        B.COMMISS_YN,									\n");
        	sqlstr.append("        B.SPETOOL_YN,									\n");
        	sqlstr.append("        B.TEST_YN,											\n");
        	sqlstr.append("        B.DOC_YN,											\n");
        	sqlstr.append("        B.PACK_YN,											\n");
        	sqlstr.append("        B.LANDTRAN_YN,									\n");
        	sqlstr.append("        B.DELIVERY_CONDITION_YN,					\n");
        	sqlstr.append("        B.DELIVERY_CONDITION,						\n");
        	sqlstr.append("        B.FEE_NOTI,										\n");
        	sqlstr.append("        B.OPTION_NOTI,									\n");
        	sqlstr.append("        B.QUOT_NO,										\n");
        	sqlstr.append("        B.PAYCONDI_YN,									\n");
        	sqlstr.append("        B.PAYCONDI_NOT_NOTI,						\n");
        	sqlstr.append("        B.CONTFUL_YN,									\n");
        	sqlstr.append("        B.CONTFUL_NOT_NOTI,							\n");
        	sqlstr.append("        B.FRSTGUAR_YN,									\n");
        	sqlstr.append("        B.FRSTGUAR_NOT_NOTI,						\n");
        	sqlstr.append("        B.WARR_YN,										\n");
        	sqlstr.append("        B.WARR_NOT_NOTI,								\n");
        	sqlstr.append("        B.DEFECT_YN,										\n");
        	sqlstr.append("        B.DEFECT_NOT_NOTI,							\n");
        	sqlstr.append("        B.BID_CONDI_NOTI,								\n");
        	sqlstr.append("        B.CBC_FIRST_RATE,								\n");
        	sqlstr.append("        B.PBC_FIRST_CONDI,							\n");
        	sqlstr.append("        B.CPC_MID_RATE,									\n");
        	sqlstr.append("        B.PBC_MID_CONDI,								\n");
        	sqlstr.append("        B.PBC_REST_RATE,								\n");
        	sqlstr.append("        B.PBC_REST_CONDI,								\n");
        	sqlstr.append("        DECODE(D.STATUS_CD,'10',F_GET_CODE_NAME('TBE_EVAL',C.EVAL_RESULT),'') AS EVAL_RESULT_NM,								\n");
        	sqlstr.append("        DECODE(D.STATUS_CD,'10',C.EVAL_RESULT,DECODE(E.ONBID_YN,'Y','',C.EVAL_RESULT))	AS EVAL_RESULT,								\n");
        	sqlstr.append("        DECODE(C.STATUS_CD,'','N','Y') AS TBE_YN,								\n");
        	sqlstr.append("        F_GET_D_CURRENCY(NVL(A.SELECT_TOT_AMT,0),F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB))) AS SEL_ITEM_AMT,							\n");
        	sqlstr.append("         DECODE(B.CURRENCY_GB,'KRW',F_GET_D_CURRENCY(A.SELECT_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB))),F_GET_D_CURRENCY(A.WON_SELECT_TOT_AMT,F_GET_CURRENCY_DIGIT(NVL(B.CURRENCY_GB,E.CURRENCY_GB)))) AS WON_SEL_TOT_AMT,								\n");
        	sqlstr.append("        (SELECT COUNT(*) FROM BID_SUPP_ESTI WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG AND VENDOR_CD = A.VENDOR_CD AND SELECT_QTY > 0) AS SEL_ITEM_QTY,     							\n");
        	sqlstr.append("        CASE WHEN A.SELECT_TOT_AMT <= 0 THEN 0              							\n");
        	sqlstr.append("        ELSE ROUND((DECODE(B.CURRENCY_GB,'KRW',A.SELECT_TOT_AMT,A.WON_SELECT_TOT_AMT)/(SELECT DECODE(ACT_AMT,0,1,NVL(ACT_AMT,1)) FROM  BID_MASTER WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG) * 100),1) END  AS SEL_TOT_RATE,        							\n");
        	sqlstr.append("        '[다운로드]' AS FILE_DOWN	\n");
        	sqlstr.append("   FROM BID_SUPP A	, BID_PUR_CONDI B, TBE_SUPP C	 , TBE_INFO D, BID_MASTER E	\n");
        	sqlstr.append(" WHERE A.BID_NO = B.BID_NO(+)					\n");
        	sqlstr.append(" AND A.BID_DEG = B.BID_DEG(+)						\n");
        	sqlstr.append(" AND A.VENDOR_CD = B.VENDOR_CD(+)			\n");
        	sqlstr.append(" AND A.BID_NO  = C.BID_NO(+)						\n");
        	sqlstr.append(" AND A.BID_DEG = C.BID_DEG(+)						\n");
        	sqlstr.append(" AND A.VENDOR_CD = C.VENDOR_CD(+)			\n");
        	sqlstr.append(" AND A.BID_NO  = D.BID_NO(+)						\n");
        	sqlstr.append(" AND A.BID_DEG = D.BID_DEG(+)						\n");
        	sqlstr.append(" AND A.BID_NO  = E.BID_NO							\n");
        	sqlstr.append(" AND A.BID_DEG = E.BID_DEG							\n");
        	sqlstr.append(" AND A.BID_NO = '"+params.get("BID_NO")+"'		\n");
        	sqlstr.append(" AND A.BID_DEG = '"+params.get("BID_DEG")+"'	\n");
        	sqlstr.append(" ORDER BY SUCC_YN DESC NULLS LAST, TBEAPPR_YN DESC NULLS LAST, A.ESTI_TOT_AMT ASC NULLS LAST	\n");
			search.setStatement(sqlstr.toString());
            rowSet = search.execute();
        }
        catch (WAFSQLException se) {
            super.doException(se);
            this.storage.setSuccess(false);
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {    
            if(rowSet == null){
            	rowSet = new RowSetImpl();
            }
        }
        
        return rowSet;
	}
	
	/**
	 * 발주의뢰 결재 정보 조회
	 * @param DEMANDED_ID
	 * @return
	 */
	private ValueObject getSignInfo(String DEMANDED_ID) {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        ValueObject vo = new ValueObject();
        
        StrBuffer sqlstr = new StrBuffer();
        try{
        	sqlstr.append("SELECT DEMANDED_ID, SIGN_CLASS_CD, DOC_ID, YEAR, SIGN_DECI_CLASS, APPROVAL_DATE, APPROVAL_SABUN, APPROVAL_USER                  \n");
        	sqlstr.append("FROM (                                                                                                                    \n");
        	sqlstr.append("          SELECT A.DEMANDED_ID, C.SIGN_CLASS_CD, C.DOC_ID, TO_CHAR(C.CRE_DATE,'YYYYMMDD') YEAR, SIGN_DECI_CLASS, APPROVAL_DATE, APPROVAL_SABUN, APPROVAL_USER  \n");
        	sqlstr.append("          FROM PMM_DEMANDED_REQUEST A, ETECEPC.MR_REQ_PO B, SIGN001T C                                              \n");
        	sqlstr.append("          WHERE A.DEMANDED_ID = B.BUYREQNO                                                      \n");
        	sqlstr.append("          AND B.APPR_ID = C.SIGN_INTERFACE_ID                                                                             \n");
        	sqlstr.append("          AND  C.SIGN_CLASS_CD = 'ebid_mrD'                                                                                    \n");
        	sqlstr.append("          AND C.SIGN_DECI_CLASS IN ( '14', '24')                                                                          \n");
        	sqlstr.append("          UNION ALL                                                                                                       \n");
        	sqlstr.append("          SELECT  A.DEMANDED_ID,  SIGN_CLASS_CD, DOC_ID,TO_CHAR(B.CRE_DATE,'YYYYMMDD') YEAR,  SIGN_DECI_CLASS, APPROVAL_DATE, APPROVAL_SABUN, APPROVAL_USER    \n");
        	sqlstr.append("          FROM PMM_DEMANDED_REQUEST A, SIGN001T B                                                                   \n");
        	sqlstr.append("          WHERE  A.DEMANDED_KIND IN ('C', 'P',  'O')                                                                            \n");
        	sqlstr.append("          AND  B.SIGN_CLASS_CD = 'prD'                                                                                    \n");
        	sqlstr.append("          AND B.SIGN_DECI_CLASS IN ( '14', '24')                                                                          \n");
        	sqlstr.append("          AND A.DEMANDED_ID =  REGEXP_REPLACE(B.KEY_COL1,'[^0-9]')                                                                                  \n");
        	sqlstr.append(") A                                                                                                                       \n");
        	sqlstr.append("WHERE 1=1                                                                                                                 \n");
        	sqlstr.append("AND A.DEMANDED_ID = ?                                                                                                     \n");
        	sqlstr.append("ORDER BY DEMANDED_ID                                                                                                      \n");

        	
        	search.setStatement(sqlstr.toString());
        	search.addParameter(DEMANDED_ID);
            rowSet = search.execute();
            if(rowSet.size()>0){
            	vo = RowSetUtility.getValueObject(rowSet.getRow(0));
            }
        }
        catch (WAFSQLException se) {
            super.doException(se);
            this.storage.setSuccess(false);
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {    
            if(rowSet == null){
            	rowSet = new RowSetImpl();
            }
        }
        return vo;
	}
	
	
	/**
     * 분할낙찰 여부 초기화
	 * @param valueObject
	 * @param event
	 * @return
	 */
	public boolean clearSuppEsti(ValueObject valueObject) {
		conn.begin(); 
		StrBuffer sqlstr = new StrBuffer();
		StrBuffer sqlstr2 = new StrBuffer();
		StrBuffer sqlstr3 = new StrBuffer();
        try {
        	
        	Persistent persistent = new PersistentImpl(conn.getConnection());
        	Persistent persistent2 = new PersistentImpl(conn.getConnection());
        	Persistent persistent3 = new PersistentImpl(conn.getConnection());
        	
        	sqlstr.append("  UPDATE BID_SUPP_ESTI				\n");
        	sqlstr.append("  SET SELECT_QTY = 0					\n");
        	sqlstr.append("  WHERE BID_NO = ?					\n");
        	sqlstr.append("  AND   BID_DEG = ?					\n");
        	
        	
			sqlstr2.append("  UPDATE BID_SUPP A				\n");
			sqlstr2.append("  SET   A.SELECT_TOT_AMT = (SELECT  SUM(NVL(SELECT_QTY,0)* NVL(UNIT_COST,0)) FROM BID_SUPP_ESTI WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG AND VENDOR_CD = A.VENDOR_CD)					\n");
			sqlstr2.append("        ,  A.WON_SELECT_TOT_AMT = (SELECT  NVL(SUM(NVL(SELECT_QTY,0)* NVL(UNIT_COST,0)),0) FROM BID_SUPP_ESTI WHERE BID_NO = A.BID_NO AND BID_DEG = A.BID_DEG AND VENDOR_CD = A.VENDOR_CD) * DECODE(A.EXCHANGE, 0, 1, A.EXCHANGE)				\n");
			sqlstr2.append("        ,  A.SUCC_YN   =  'N'			\n");
			sqlstr2.append("  WHERE A.BID_NO = ?				\n");
			sqlstr2.append("  AND   A.BID_DEG = ?				\n");

			sqlstr3.append("  UPDATE BID_MASTER A				\n");
			sqlstr3.append("  SET   A.DIV_CONT_YN = 'N'				\n");
			sqlstr3.append("  WHERE A.BID_NO = ?				\n");
			sqlstr3.append("  AND   A.BID_DEG = ?				\n");
			
        	
        	
            persistent.setStatement(sqlstr.toString());
			persistent.addParameter(params.get("BID_NO"));
			persistent.addParameter(params.get("BID_DEG"));
            persistent.execute();
            

            persistent2.setStatement(sqlstr2.toString());
            persistent2.addParameter(params.get("BID_NO"));
            persistent2.addParameter(params.get("BID_DEG"));
            persistent2.execute();

            persistent3.setStatement(sqlstr3.toString());
            persistent3.addParameter(params.get("BID_NO"));
            persistent3.addParameter(params.get("BID_DEG"));
            persistent3.execute();
            
            
            
            
            
            return true;
        }
        catch(Exception e) {
            WAFLogger.error(this.getClass().getName() + " --> BidmasterStatusUpdate() : " + e.getMessage());
            WAFLogger.error(e);
            conn.setRollback();
            storage.setDetailMessage(e);
            return false;
        }
        finally {
        	
            conn.end();
        }
    }
}